-- ========================================================================== --
-- 										 EskaQuestTracker                                       --
-- @Author   : Skamer <https://mods.curse.com/members/DevSkamer>              --
-- @Website  : https://wow.curseforge.com/projects/eska-quest-tracker         --
-- ========================================================================== --
Scorpio                "EskaQuestTracker.Options.OptionBuilder"          "1.0.0"
-- ========================================================================== --
namespace "EQT"                                                               --
import "System"                                                               --
-- ========================================================================== --

__Unique__()
class "OptionBuilder"
--[[__Arguments__ { Class, String }
function CreateTextOptions(self, class, property)
  return {
    type = "range",
    name = "Text Scenario",
    get = function() return class:GetTextSize("name") end,
    set = function(_, value) class:SetTextSize("name", value) end,
  }
end--]]

__Arguments__ { Class, String }
function CreateTextOptions(self, class, element)
  return {
    textSize = {
      type = "range",
      name = "Text Size",
      order = 1,
      step = 1,
      min = 4,
      max = 32,
      get = function() return class:GetTextSize(element) end,
      set = function(_, value) class:SetTextSize(element, value) end,
    },
    textFont = {
      type = "select",
      name = "Text Font",
      values = _Fonts,
      itemControl = "DDI-Font",
      get = function() return GetFontIndex(class:GetTextFont(element)) end,
      set = function(_, value) class:SetTextFont(element, _Fonts[value]) end,
    },
    textColor = {
      type = "color",
      name = "Text color",
      get = function()
        --local color = class:GetTextColor(element)
        local color = class:GetTextColor(element)
        return color.r, color.g, color.b
      end,
      set = function(_, r, g, b, a)
        class:SetTextColor(element, {
          r = r, g = g, b = b
        })
      end
    },
    textTransform = {
      type = "select",
      name = "Text Transform",
      values = _TextTransforms,
      get = function() return class:GetTextTransform(element) end,
      set = function(_, value) class:SetTextTransform(element, value) end,
    }
  }
end


endclass "OptionBuilder"
